postgresql-12 (12.22-0ubuntu0.20.04.4) focal-security; urgency=medium

  * SECURITY UPDATE: crash via incomplete multibyte character
    - debian/patches/CVE-2025-4207.patch: with GB18030, prevent SIGSEGV
      from reading past end of allocation in
      src/backend/utils/mb/mbutils.c, src/backend/utils/mb/wchar.c,
      src/include/mb/pg_wchar.h, src/interfaces/libpq/fe-exec.c,
      src/interfaces/libpq/fe-misc.c,
      src/test/modules/test_escape/test_escape.c.
    - CVE-2025-4207

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 12 May 2025 14:17:28 +0200

postgresql-12 (12.22-0ubuntu0.20.04.3) focal; urgency=medium

  * Avoid using timezone Asia/Manila in regression tests (LP: #2095233)

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 20 Mar 2025 15:30:18 +0100

postgresql-12 (12.22-0ubuntu0.20.04.2) focal-security; urgency=medium

  * SECURITY UPDATE: PostgreSQL quoting APIs miss neutralizing quoting
    syntax in text that fails encoding validation
    - debian/patches/CVE-2025-1094-*.patch: backport security fixes from
      REL_13_STABLE branch.
    - CVE-2025-1094

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 17 Feb 2025 11:44:17 -0500

postgresql-12 (12.22-0ubuntu0.20.04.1) focal-security; urgency=medium

  * New upstream version (LP: #2085196).

    + This release encompasses changes from upstream's 12.21 and 12.22
      releases.  The former contains fixes for 4 CVEs (among other
      things), and the latter was hotfix for a problem caused by one of
      the CVE fixes from 12.21.

    + A dump/restore is not required for those running 12.X.

    + However, if you are upgrading from a version earlier than 12.18, see
      those release notes as well please.

    + Ensure cached plans are marked as dependent on the calling role when
      RLS applies to a non-top-level table reference (Nathan Bossart)

      If a CTE, subquery, sublink, security invoker view, or coercion
      projection in a query references a table with row-level security
      policies, we neglected to mark the resulting plan as potentially
      dependent on which role is executing it.  This could lead to later query
      executions in the same session using the wrong plan, and then returning
      or hiding rows that should have been hidden or returned instead.

      The PostgreSQL Project thanks Wolfgang Walther for reporting this
      problem.
      (CVE-2024-10976)

    + Make libpq discard error messages
      received during SSL or GSS protocol negotiation (Jacob Champion)

      An error message received before encryption negotiation is completed
      might have been injected by a man-in-the-middle, rather than being real
      server output.  Reporting it opens the door to various security hazards;
      for example, the message might spoof a query result that a careless user
      could mistake for correct output.  The best answer seems to be to
      discard such data and rely only on libpq's own report of the connection
      failure.

      The PostgreSQL Project thanks Jacob Champion for reporting this
      problem.
      (CVE-2024-10977)

    + Fix unintended interactions between SET SESSION AUTHORIZATION
      and SET ROLE (Tom Lane)

      The SQL standard mandates that SET SESSION AUTHORIZATION have a
      side-effect of doing SET ROLE NONE.  Our implementation of that was
      flawed, creating more interaction between the two settings than
      intended.  Notably, rolling back a transaction that had done SET SESSION
      AUTHORIZATION would revert ROLE to NONE even if that had not been the
      previous state, so that the effective user ID might now be different
      from what it had been before the transaction.  Transiently setting
      session_authorization in a function SET clause had a similar effect.  A
      related bug was that if a parallel worker inspected
      current_setting('role'), it saw none even when it should see something
      else.

      The PostgreSQL Project thanks Tom Lane for reporting this problem.
      (CVE-2024-10978)

    + Prevent trusted PL/Perl code from changing environment variables
      (Andrew Dunstan, Noah Misch)

      The ability to manipulate process environment variables such as PATH
      gives an attacker opportunities to execute arbitrary code.  Therefore,
      trustedPLs must not offer the ability to do that.  To fix plperl,
      replace %ENV with a tied hash that rejects any modification attempt with
      a warning.  Untrusted plperlu retains the ability to change the
      environment.

      The PostgreSQL Project thanks Coby Abrams for reporting this problem.
      (CVE-2024-10979)

    + Restore functionality of ALTER {ROLE|DATABASE} SET
      role (Tom Lane, Noah Misch)

      The fix for CVE-2024-10978 accidentally caused settings for role to
      not be applied if they come from non-interactive sources, including
      previous ALTER {ROLE|DATABASE} commands and the PGOPTIONS environment
      variable.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/12/release-12-21.html and
      https://www.postgresql.org/docs/12/release-12-22.html.

  * d/postgresql-12.NEWS: Update.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 25 Nov 2024 15:41:36 -0500

postgresql-12 (12.20-0ubuntu0.20.04.1) focal-security; urgency=medium

  * New upstream version (LP: #2076183).

    + A dump/restore is not required for those running 12.X.

    + However, if you are upgrading from a version earlier than 12.18, see
      those release notes as well please.

    + Prevent unauthorized code execution during pg_dump (Masahiko Sawada)

      An attacker able to create and drop non-temporary objects could inject
      SQL code that would be executed by a concurrent pg_dump session with the
      privileges of the role running pg_dump (which is often a superuser).
      The attack involves replacing a sequence or similar object with a view
      or foreign table that will execute malicious code.  To prevent this,
      introduce a new server parameter restrict_nonsystem_relation_kind that
      can disable expansion of non-builtin views as well as access to foreign
      tables, and teach pg_dump to set it when available.  Note that the
      attack is prevented only if both pg_dump and the server it is dumping
      from are new enough to have this fix.

      The PostgreSQL Project thanks Noah Misch for reporting this problem.
      (CVE-2024-7348)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/12/release-12-20.html.

  * d/postgresql-12.NEWS: Update.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 06 Aug 2024 15:15:12 -0300

postgresql-12 (12.19-0ubuntu0.20.04.1) focal; urgency=medium

  * New upstream version (LP: #2067388).

    + A dump/restore is not required for those running 12.X.

    + Also, if you are upgrading from a version earlier than 12.18, see
      those release notes as well please.

    + Fix INSERT from multiple VALUES rows into a target column that is a
      domain over an array or composite type (Tom Lane)

      Such cases would either fail with surprising complaints about
      mismatched datatypes, or insert unexpected coercions that could lead
      to odd results.

    + Fix incorrect pruning of NULL partition when a table is partitioned
      on a boolean column and the query has a boolean IS NOT clause (David
      Rowley)

      A NULL value satisfies a clause such as boolcol IS NOT FALSE, so
      pruning away a partition containing NULLs yielded incorrect answers.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/12/release-12-19.html

  * d/postgresql-12.NEWS: Update.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 28 May 2024 09:30:50 -0400

postgresql-12 (12.18-0ubuntu0.20.04.1) focal-security; urgency=medium

  * New upstream version (LP: #2052850).

    + A dump/restore is not required for those running 12.X.

    + However, one bug was fixed that could have resulted in corruption of
      GIN indexes during concurrent updates.  If you suspect such
      corruption, reindex affected indexes after installing this update.

    + Also, if you are upgrading from a version earlier than 12.17, see
      those release notes as well please.

    + Tighten security restrictions within REFRESH MATERIALIZED
      VIEW CONCURRENTLY (Heikki Linnakangas)

      One step of a concurrent refresh command was run under weak security
      restrictions.  If a materialized view's owner could persuade a
      superuser or other high-privileged user to perform a concurrent
      refresh on that view, the view's owner could control code executed
      with the privileges of the user running REFRESH.
      Fix things so that all user-determined code is run as the view's
      owner, as expected.

      The only known exploit for this error does not work in PostgreSQL
      16.0 and later, so it may be that v16 is not vulnerable in practice.

      The PostgreSQL Project thanks Pedro Gallegos for reporting this
      problem.
      (CVE-2024-0985)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/12/release-12-18.html

  * d/postgresql-12.NEWS: Update.


 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Thu, 15 Feb 2024 15:19:37 -0300

postgresql-12 (12.17-0ubuntu0.20.04.1) focal-security; urgency=medium

  * New upstream version (LP: #2040469).

    + A dump/restore is not required for those running 12.X.

    + However, if you use GiST indexes, it may be advisable to reindex them.

    + Also, if you are upgrading from a version earlier than 12.16, see
      those release notes as well please.

    + Fix handling of unknown-type arguments in DISTINCT "any" aggregate
      functions (Tom Lane)

      This error led to a text-type value being interpreted as an unknown-type
      value (that is, a zero-terminated string) at runtime. This could result
      in disclosure of server memory following the text value.
      (CVE-2023-5868)

    + Detect integer overflow while computing new array dimensions
      (Tom Lane)

      When assigning new elements to array subscripts that are outside the
      current array bounds, an undetected integer overflow could occur in edge
      cases. Memory stomps that are potentially exploitable for arbitrary code
      execution are possible, and so is disclosure of server memory.
      (CVE-2023-5869)

    + Prevent the <literal>pg_signal_backend</literal> role from
      signalling background workers and autovacuum processes (Noah Misch,
      Jelte Fennema-Nio)

      The documentation says that pg_signal_backend cannot issue signals to
      superuser-owned processes. It was able to signal these background
      processes, though, because they advertise a role OID of zero. Treat that
      as indicating superuser ownership. The security implications of
      cancelling one of these process types are fairly small so far as the
      core code goes (we'll just start another one), but extensions might add
      background workers that are more vulnerable.

      Also ensure that the is_superuser parameter is set correctly in such
      processes. No specific security consequences are known for that
      oversight, but it might be significant for some extensions.
      (CVE-2023-5870)

    + Fix misbehavior during recursive page split in GiST index build
      (Heikki Linnakangas)

      Fix a case where the location of a page downlink was incorrectly
      tracked, and introduce some logic to allow recovering from such
      situations rather than silently doing the wrong thing.  This error
      could result in incorrect answers from subsequent index searches.
      It may be advisable to reindex all GiST indexes after installing
      this update.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/12/release-12-17.html.

  * d/p/libpgport-pkglibdir: Adjust patch to reflect upstream changes.

  * d/p/50-per-version-dirs.patch: Adjust TestLib.pm's
    scan_server_header and check_pg_config to account for
    unrelocatability of pg_config.
    These changes are needed because, during build time,
    we want to be able to run the upstream tests using the pg_config
    binary from inside the "debian/" directory, but that doesn't work out
    of the box because it will print includedir paths that also point to
    "debian/", instead of to "/usr/include".  Therefore, we need to catch
    this specific scenario and print the proper includedir paths instead.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 22 Nov 2023 21:50:50 -0500

postgresql-12 (12.16-0ubuntu0.20.04.1) focal-security; urgency=medium

  * New upstream version (LP: #2028426).

    + A dump/restore is not required for those running 12.X.

    + However, if you use BRIN indexes, it may be advisable to reindex them.

    + Also, if you are upgrading from a version earlier than 12.10, see
      those release notes as well please.

    + Disallow substituting a schema or owner name into an extension script
      if the name contains a quote, backslash, or dollar sign (Noah Misch)

      This restriction guards against SQL-injection hazards for trusted
      extensions.
      (CVE-2023-39417)

    + Fix confusion between empty (no rows) ranges and all-NULL ranges in
      BRIN indexes, as well as incorrect merging of all-NULL summaries
      (Tomas Vondra)

      Each of these oversights could result in forgetting that a BRIN
      index range contains any NULL values, potentially allowing
      subsequent queries that should return NULL values to miss doing so.

      This fix will not in itself correct faulty BRIN entries.
      It's recommended to REINDEX any BRIN indexes that
      may be used to search for nulls.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/12/release-12-16.html.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 11 May 2023 15:58:10 -0400

postgresql-12 (12.15-0ubuntu0.20.04.1) focal-security; urgency=medium

  * New upstream version (LP: #2019214).

    + A dump/restore is not required for those running 12.X.

    + Also, if you are upgrading from a version earlier than 12.10, see
      those release notes as well please.

    + Prevent CREATE SCHEMA from defeating changes in search_path
      (Alexander Lakhin)

      Within a CREATE SCHEMA command, objects in the prevailing
      search_path, as well as those in the newly-created schema, would be
      visible even within a called function or script that attempted to set
      a secure search_path. This could allow any user having permission to
      create a schema to hijack the privileges of a security definer
      function or extension script.
      (CVE-2023-2454)

    + Enforce row-level security policies correctly after inlining a
      set-returning function (Stephen Frost, Tom Lane)

      If a set-returning SQL-language function refers to a table having
      row-level security policies, and it can be inlined into a calling
      query, those RLS policies would not get enforced properly in some
      cases involving re-using a cached plan under a different role. This
      could allow a user to see or modify rows that should have been
      invisible.
      (CVE-2023-2455)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/12/release-12-15.html.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 11 May 2023 15:58:10 -0400

# For older changelog entries, run 'apt-get changelog postgresql-pltcl-12'
